awoo's blog

By awoo, history, 5 years ago, translation, In English

1175A - From Hero to Zero

Idea: Roms

Tutorial
Solution (Roms)

1175B - Catch Overflow!

Idea: awoo

Tutorial
Solution (PikMike)

1175C - Electrification

Idea: adedalic

Tutorial
Solution (adedalic)

1175D - Array Splitting

Idea: adedalic

Tutorial
Solution (Roms)

1175E - Minimal Segment Cover

Idea: adedalic

Tutorial
Solution 1 (PikMike)
Solution 2 (PikMike)

1175F - The Number of Subpermutations

Idea: Roms

Tutorial
Solution (Roms)

1175G - Yet Another Partiton Problem

Idea: adedalic

Tutorial
Solution (adedalic)
  • Vote: I like it
  • +76
  • Vote: I do not like it

| Write comment?
»
5 years ago, # |
  Vote: I like it +11 Vote: I do not like it

Can someone explain the idea of https://codeforces.com/contest/1175/submission/55197107? Seems he uses a deque, but why his solution is correct?

»
5 years ago, # |
  Vote: I like it +4 Vote: I do not like it

Less mathematical explanation of C,anyone ?

  • »
    »
    5 years ago, # ^ |
      Vote: I like it +6 Vote: I do not like it

    Let's consider this query: $$$n = 7$$$, $$$k = 4$$$, $$$a$$$ = {1, 4, 5, 7, 10, 14, 16}. Let's consider a range of $$$k = 4$$$ consecutive elements of $$$a$$$: {1, 4, 5, 7}. For some certain $$$x$$$, these are the 4 closest values in $$$a$$$. The 4th-closest value is the farther of 1 and 7. $$$f_k(x)$$$ is then $$$max(x - 1, 7 - x)$$$. To minimize this expression, we set $$$x$$$ to the average of 1 and 7. This is necessarily the minimum of $$$f_k(x)$$$ for all $$$x$$$ where the four closest elements of $$$a$$$ are from that set. Note that the first and last of this set must be $$$k$$$ apart, and we don't care about what's between them.

    No $$$x$$$ will ever occur where its closest $$$k$$$ elements of $$$a$$$ are not consecutive. So, we just need to find the minimum of the minimum $$$f_k(x)$$$'s from each of these ranges, i.e. the minimum value of $$$\frac{a_i+a_{i + k}}{2}$$$ for all valid $$$i$$$. This takes constant time for each check, so the solution is $$$O(n)$$$ time.

    There was certainly a gap in my logic somewhere here, but I think I got the point across. Sorry for explaining too much and overcomplicating. :P

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      I looked back at my own solution; it seems like I did an unnecessary sort to end up with an $$$O(n\log(n))$$$ solve. I didn't realize until now why I had a 1200 ms test case. Wow.

    • »
      »
      »
      5 years ago, # ^ |
      Rev. 2   Vote: I like it 0 Vote: I do not like it

      Why do we take x as the average of a[i] and a[i+k] for calculation?

      • »
        »
        »
        »
        5 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        If $$$x$$$ is closer to one end, $$$f_k(x)$$$ is the distance to the farther one. To minimize "the distance to the farther one," $$$x$$$ can't be closer to either end. This happens at the average, where $$$x$$$ is equally far from both ends.

        If you look at the graphs for $$$y = x - p$$$ and $$$y = q - x$$$, it's two lines. When you take the maximum value of $$$y$$$ at all values of $$$x$$$, you get a v-shape. The bottom of this v (where the lines intersect) is where y is minimized, and with some calculation, you find this is the average of $$$p$$$ and $$$q$$$.

    • »
      »
      »
      3 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      why are you taking the 4th distance , shouldnt you take k+1 th distance?

  • »
    »
    5 years ago, # ^ |
    Rev. 5   Vote: I like it +1 Vote: I do not like it

    Suppose that you will brute force it, then you have a list of distances, and you sort it. You want the k-th element of it.

    Let the input be something like: [..., ?, ?, A, B, C, D, E, ?, ?, ...], with K = 3.

    Notice that if you choose C as the answer, the nearest points would be one of these:

    • A, B, C
    • B, C, D
    • C, D, E

    All the other points will certainly be farther from C.

    So the problem is all about finding a segment with the lowest value for the farthest element in this interval, which is in the middle.

    Keep looking a window of size K and get the middle point of it. Choose any interval with the lowest of these values.

    Hope it helps :D

»
5 years ago, # |
  Vote: I like it +5 Vote: I do not like it

Did anyone write autor's solution in F?

  • »
    »
    5 years ago, # ^ |
    Rev. 2   Vote: I like it 0 Vote: I do not like it

    Although I didn't write it,I can explain it if you have any questions.

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      I got the idea but I just found hashing multiset of numbers through xor sum very exotic.

      • »
        »
        »
        »
        5 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        I think it's exotic, too, but it taught me a new hash method.

        • »
          »
          »
          »
          »
          5 years ago, # ^ |
            Vote: I like it +8 Vote: I do not like it

          You tried to help me so let me try to help you.

          There is another way to hash multiset. So let number $$$i$$$ occurs in multiset $$$arr_i$$$ times. Then hash of multiset would be $$$\sum X^{arr_i}$$$ where $$$X$$$ is some prime number.

          Maybe that's widely known but I learned that several days ago.

          • »
            »
            »
            »
            »
            »
            5 years ago, # ^ |
            Rev. 2   Vote: I like it +8 Vote: I do not like it

            This hashing method really enhances my knowledge! I have never heard it before. Thanks a lot.

            • »
              »
              »
              »
              »
              »
              »
              5 years ago, # ^ |
                Vote: I like it 0 Vote: I do not like it

              You are welcome, but I got wrong!

              Hash of multiset equeals $$$\sum X^i$$$ for every $$$i$$$ from multiset. Now let $$$A$$$ and $$$B$$$ be some multisets. So now we can see that hash of $$$(A + B)$$$ is really easy to calculate cause it is just a sum of hash of $$$A$$$ and hash of $$$B$$$.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

For problem G, how to prove that $$$opt(i, j) < opt(i, j+1)$$$, where $$$opt(i, j)$$$ is the optimal value for calculating $$$dp[i][j]$$$? We need this in order to apply the Divide and Conquer DP optimization.

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    It seems like Um_nik tried to implement this DP optimization and it didn't work.

    DnC I was talking about is not an optimization. It described in this comment.

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Thank you! It seems that everyone who tried implementing this failed the 4th test case.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can anyone explain the binary search solution (accepted) for problem C ?
I was doing during the contest with binary search but couldn't get AC.

  • »
    »
    5 years ago, # ^ |
      Vote: I like it +4 Vote: I do not like it

    The idea is to binary search on minimum distance.

    Lets say distance is d then for all i (1 to n) we can form up segments [A[i] — d, A[i] + d]

    Now check if there are minimum k+1 intersections of these segments if yes it means we can find point x such that kth value would be d.

»
5 years ago, # |
  Vote: I like it +3 Vote: I do not like it

anupamshah_ make a sliding window of length k(k points) and just take the midpoint of it's endpoints. Take the minimum length window.

»
5 years ago, # |
Rev. 2   Vote: I like it +7 Vote: I do not like it

can someone explain how binary lifting is applied in E ?

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Basically the same way it's done on trees. After you precalculated $$$up[j][i]$$$ (the index of the last taken interval if you started from $$$i$$$ and took $$$2^j$$$ intervals greedily), you set the current interval $$$cur$$$ to the one which starts to the left or at $$$x$$$ and ends as much to the right as possible, then iterate over $$$j$$$ from $$$\log n$$$ down to $$$0$$$ and set $$$cur$$$ equal to $$$up[j][cur]$$$ if the right border of $$$up[j][cur]$$$ is strictly to the left of $$$y$$$. $$$2^j$$$ is added to answer then. In the end $$$up[0][cur]$$$ should be the interval which covers $$$y$$$.

    You just have to handle some cases carefully: if the first interval covers $$$y$$$ already and if -1 is reached. You can refer to my code in editorial for implementation.

    • »
      »
      »
      5 years ago, # ^ |
      Rev. 2   Vote: I like it 0 Vote: I do not like it

      So we are making up[j][i] for each position of i ? or we are doing it for each interval i ?

      • »
        »
        »
        »
        5 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        The way I described it, it's for each interval. However, doing it for each position is also possible, just the application slightly changes.

        • »
          »
          »
          »
          »
          5 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          Oh ok so we calculate for each segment the next segment that is left or equal to its right and is as long as possible and that will be up[i][0] for it and so on calculate for all even powers upto logn. And then apply Binary lifting technique to the queries. Am i right ?

          • »
            »
            »
            »
            »
            »
            5 years ago, # ^ |
              Vote: I like it 0 Vote: I do not like it

            Yup, that's right.

        • »
          »
          »
          »
          »
          4 years ago, # ^ |
            Vote: I like it 0 Vote: I do not like it

          How to deal it for each position ?

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      can you suggest problem on binary lifting , but not on trees .

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    sparseTable[i][j] = maximum position which can be reached from i'th point using (1 << j) intervals.

    Base Case : sparseTable[i][0] = max(sparseTable[i-1][0], be[i][j]). where be[i][j] = right endpoint of all intervals starting at i.

    Update : sparseTable[i][j] = sparseTable[sparseTable[i][j-1]][j-1] i.e. taking a jump of length (1 << (j-1)) from i and another one of length (1 << (j-1)) from point reached by previous jump.

    Query : Start from x. Consider all jumps of length power of two from largest to smallest. If by taking a jump we can reach a index less than y(note : not equal to y) update x to that index.

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      Thanks for the explanation. It helped me !

»
5 years ago, # |
Rev. 2   Vote: I like it +8 Vote: I do not like it

For problem F, there is a way of two pointer approach to check if the interval is a permutation, instead of using random distribution.

Assuming that we are going to handle the cases when $$$A \leq l \leq B \leq r \leq C$$$ and the maximum element is on the right of position $$$B$$$, let's set the current interval $$$[l, r]$$$ as $$$[B, B]$$$ and build a boolean array that records whether some value occur in the current interval.

Then we enumerate and move $$$r$$$ from $$$B$$$ to $$$C$$$. During that process, we move $$$l$$$ to the leftmost such that there is no duplicated element in $$$[l, r]$$$ and $$$r + 1 - \max(a_{B}, a_{B + 1}, \ldots, a_{r}) \leq l \leq B$$$. After moving, we check if $$$l = r + 1 - \max(a_{B}, a_{B + 1}, \ldots, a_{r})$$$ and $$$\max(a_{l}, a_{l + 1}, \ldots, a_{r}) = \max(a_{B}, a_{B + 1}, \ldots, a_{r})$$$.

Note that $$$l$$$ won't move right more than $$$(C - B)$$$ times, and of course won't move left more than $$$(C - A)$$$ times, so the complexity is guaranteed.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Anyone keep getting wrong answer on test 5 for question B?

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    yes!! Me. I get :

    wrong answer 1st words differ — expected: '200000000', found: '0'

    and my sol is : https://codeforces.com/contest/1175/submission/55274658/

    Someone please help us!!

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      You are checking for overflow only at the end. Even in the middle, the value of mul can exceed the size of long long int itself.

      • »
        »
        »
        »
        5 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        Yes I understand that, but you can't simply take it into account as, if we encounter an "end" before an "add", then that value will be discarded. SO, we have to check value of mul while we are adding it. Also, I am making sure it's maximum value is (2^32) only.

        • »
          »
          »
          »
          »
          5 years ago, # ^ |
          Rev. 2   Vote: I like it 0 Vote: I do not like it

          mul/=rem.top(); rem.pop();

          What about this? If mul is 2^32, isn't it wrong to divide it by rem.top() ? I think you meant to push 2^32 instead.

»
5 years ago, # |
  Vote: I like it +24 Vote: I do not like it

In problem F, you can easily test in constant time if a subsegment is a permutation of $$$1..x$$$ by precomputing the following:

  • For each $$$r$$$, the value $$$c_r$$$ — the left end of the largest segment ending on $$$r$$$ such that it has unique values
  • A sparse table for constant time maximum queries.

A subsegment $$$l, r$$$ is a permutation if $$$l \geq c_r$$$ and $$$rangeMax(l,r) = r-l+1$$$.

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Can you explain the calculation of value $$$c_r$$$?

    • »
      »
      »
      5 years ago, # ^ |
      Rev. 3   Vote: I like it 0 Vote: I do not like it
      for (int i=1; i<=n; i++) {
          c[i] = max(c[i-1], seen[a[i]]+1);
          seen[a[i]] = i;
      }
      

      where $$$a$$$ is the given $$$1$$$-indexed array, $$$seen$$$ is an array initially filled with zeros.

      • »
        »
        »
        »
        5 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        And how to search all subarray within time limit? For each i search from c[i] to i, or only search i which a[i] == 1?

        • »
          »
          »
          »
          »
          5 years ago, # ^ |
          Rev. 2   Vote: I like it 0 Vote: I do not like it

          I figured it out. Just use $$$c_r$$$, rmqMax and rmqMin to replace the hash function. Sorry for my dumb question.

  • »
    »
    5 years ago, # ^ |
    Rev. 2   Vote: I like it +19 Vote: I do not like it

    Very nice solution.

    While a sparse table is indeed the more intuitive way to do it, the problem can also be solved in linear time by exploiting the following fact: If a sequence of $$$n$$$ distinct positive elements has sum $$$\frac{n(n+1)}{2}$$$, then that sequence is a permutation of numbers $$$1$$$ through $$$n$$$.

    Here is my solution using that idea: 55276406

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it +3 Vote: I do not like it

      Brilliant, thanks!

    • »
      »
      »
      5 years ago, # ^ |
        Vote: I like it 0 Vote: I do not like it

      sir , 1 2 3 4 5 — sum is 15 1 3 3 3 5 — sum is 15 so how your statement is correct ? can you explain my doubt i also thought this ?

      • »
        »
        »
        »
        5 years ago, # ^ |
          Vote: I like it 0 Vote: I do not like it

        Read carefully : He said first condition is that numbers in the given range must be unique and after that you can apply this n*(n+1)/2 part .

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    One can also replace sparse table with a stack of maximums to calculate previous maximum.

»
5 years ago, # |
Rev. 2   Vote: I like it +1 Vote: I do not like it

Can someone please explain why he wrote : " That way the maximum value you can achieve is about 2^32*50000, which fits into the 64-bit integer. " in the solution of B Catch Overflow

  • »
    »
    5 years ago, # ^ |
    Rev. 2   Vote: I like it +8 Vote: I do not like it

    that maximum value : 2^32*50000 is the maximum value of res in his ediorial code. let's take this test case:

    100000
    for 100 //
    for 100
    ...
    for 100 // 5 times 
    add //
    add
    add
    add
    ...
    add // 99990 times of add
    end  //
    end
    ...
    end // 5 times
    

    So after about 5 "for 100", cur.top() will be 1*10^10 and therefore cur.top() will be 2^32 from now on (2^32<10^10). As there are 99990 times of add, each time res+=cur.top() (which is res+=2^32). And finnally res will be 99990.2^32 — still fits the 64-bit integer.

    But if we don't take the min(INF, cur.top()*x) (INF is 2^32), then: First, stack cur will be overflowed because the value doesn't fit the 64-bit integer. (cur.top() can be 100^49999 as there are 49999 times of "for 100") Second, long long res will also be overflowed

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Question about problem $$$F.$$$

I understand that it is necessary for $$$f(l,r)$$$ to be equal to the xor of the first $$$r-l+1$$$ positive integers. However, how do we know this is sufficient to conclude that $$$a_l, a_{l+1}, \cdots, a_r$$$ are indeed a permutation of $$$1,2,\cdots, r-l+1?$$$ For example, the list of numbers $$$1,1,3,7$$$ has a total xor of $$$4,$$$ but this is also the xor of $$$1,2,3,4.$$$ Thus, how does the solution know that simply checking this condition is sufficient to show a subpermutation?

  • »
    »
    5 years ago, # ^ |
      Vote: I like it +3 Vote: I do not like it

    The author's solution first performs hashing by replacing each number $$$1..N$$$ with a random 128-bit number (two 64-bit numbers actually). It compares the xors of those replaced numbers, not the original ones.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

For problem E solution 2 how are they claiming that all the queries can be done in linear time? Path compression will take logarithmic time. Can anybody please explain..

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

In problem F ( The number of subpermutation ) why we have taken 128 bit strings for hashing purpose , i mean why we did not take 64 bit string or 128+64 bit string ?? and How to select number of string bits required to be on safe side ?

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    I tried by changing the bits used for hashing and submitting the authors soln in this manner 128 -> 64 -> 50 -> 40 -> 30 -> 28 -> 26 -> 24

    and it gave WA when 24 bits were used , then i tried 25 bits and it worked ? one more query is it possible to design testcases to break higher bits soln .

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Excuse me for my poor English, but I really can't find anything that is about "partiton" and the problem G at the same time.

Is it actually "partition" or something?

Searched "partiton" at https://fanyi.baidu.com/ and only got the explanation for "partition", so ...

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

for problem d , how can i get that idea,which features can inspire me?

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can someone please explain the second technique i.e. path compression style in the editorial of Problem E. I tried but can understand it completely. I tried to google path compression but can't find anything other than path compression in DSU.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

can any one explain problem C Electrification 3 2 1 2 5 why we chose 3 not 2? coz if we chose 3=

1 2 5
we get
2 1 2 
after sort==1 2 2 for k=2 we get 2

but if we choose 2
1 2 5
we get 
1 0 3
after sort=
0 1 3


now we can clearly say for k=2 '1' is smaller for 2.

  • »
    »
    5 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    You take the $$$k+1$$$'th number after sorting, so if you choose 2, you get 3.

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Can someone explain better how the second optimization is applied in Div2-E ?

»
5 years ago, # |
  Vote: I like it 0 Vote: I do not like it

For problem F, I think of hash a subarray as (x + a[l])(x + a[l+1])...(x + a[r]) with random value of x and random prime small modulo such as 10000079 then ultilize FFT but it seems not work because of the the probability of repetition is too high :<<

»
5 years ago, # |
  Vote: I like it +8 Vote: I do not like it

Roms in your solution for problem F, it is asked to map each no. to a random 128-bit string. I believe for that purpose, you are using a pair<long long, long long> to store it. But you are using mt19937 which as per this blog can only generate 32-bit numbers, and to generate 64-bit numbers you should be using mt19937_64. So, isn't the model solution only mapping nos. to random 64-bit numbers? Can you please check?

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

Does DP approach for problem D got Time Exceed? Apart from it, could you help me how to use DP for D problem?

»
4 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

My solution for problem B using logarithm to avoid overflow. (https://codeforces.com/problemset/submission/1175/74378404)

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

For question D My logic: keep on getting index with minimum prefix sum till now, in order to have those indices with minimum effect in my answer using a priority_queue? I get WA on test case 7. Can you tell me why am i wrong? Can't find a test case for it. Any help is much appreciated. Thanks a lot Problem 1175D - Array Splitting My submission : 77223612

»
4 years ago, # |
  Vote: I like it 0 Vote: I do not like it

I did C with order statistics, binary searching the distance

  • »
    »
    4 years ago, # ^ |
      Vote: I like it 0 Vote: I do not like it

    Can you please explain how you solved it using binary search? Like on what basics to check left or right path.

»
4 years ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

How do I make my $$$nlogn*logn$$$ Binary Search + Prefix Sums solution pass on C?

https://codeforces.com/contest/1175/submission/85123220

»
3 years ago, # |
Rev. 3   Vote: I like it 0 Vote: I do not like it

Alternative solution for 1175F - The Number of Subpermutations
Let's count the subpermutations $$$[l, r]$$$ such that $$$a_l > a_r$$$ (then, reverse the array to find the other subpermutations).
For each $$$i$$$ calculate $$$f_i$$$, the maximum position such that $$$a_i, \dots, a_{f_i}$$$ are distinct.
It's easy to prove that, for each $$$l$$$, the only possible $$$r$$$ is the maximum position such that $$$r \leq f_l$$$ and $$$a_l > a_r$$$. $$$[l, r]$$$ is a subpermutation iff the sum of the $$$a_i$$$ ($$$l \leq i \leq r$$$) is equal to the sum of the $$$i$$$ from $$$1$$$ to $$$r-l+1$$$.
Then, you can solve the problem offline by iterating over the value of $$$a_l$$$ (from $$$1$$$ to $$$n$$$) and finding $$$r$$$ by keeping a set with the positions of the elements $$$< a_l$$$.

»
9 months ago, # |
  Vote: I like it 0 Vote: I do not like it

can some one explain how can F be solved with segment tree? Example submission https://codeforces.com/contest/1175/submission/55143004

»
4 months ago, # |
  Vote: I like it 0 Vote: I do not like it

I tried to construct the tree explicitly and do binary lifting on the tree I guess I overcomplicated it Turns out its DP and its just a sparse table

»
5 weeks ago, # |
Rev. 2   Vote: I like it 0 Vote: I do not like it

wow

»
3 weeks ago, # |
  Vote: I like it 0 Vote: I do not like it

There is no need for XOR-hashing in F, we can solve it in $$$O(n)$$$ with deques by maintaing suffix maximums as we iterate over the potential rightbound of a subpermutation: 250062852